unit MirrorMain;

{ MIRROR 0.1.2 (Mar  8, 2000) - a frontend for GNU wget
  Copyright (C) 1999-2000 Wolf Behrenhoff <wolf@behrenhoff.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program. If not, write to the Free Software
  Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, shellapi, ExtCtrls, Grids;

type
  TMainForm = class(TForm)
    URLEdit: TEdit;
    Label1: TLabel;
    DownloadBtn: TButton;
    GroupBox1: TGroupBox;
    opt_continue: TCheckBox;
    opt_timestamping: TCheckBox;
    GroupBox2: TGroupBox;
    opt_recursive: TCheckBox;
    opt_level: TCheckBox;
    levelEdit: TEdit;
    opt_mirror: TCheckBox;
    recursiveOptionsGB: TGroupBox;
    opt_span_hosts: TCheckBox;
    opt_no_parent: TCheckBox;
    AboutBtn: TButton;
    opt_relative: TCheckBox;
    opt_follow_ftp: TCheckBox;
    MoreOptionsBtn: TButton;
    opt_convert_links: TCheckBox;
    Label3: TLabel;
    directory_prefixEdit: TEdit;
    procedure AboutBtnClick(Sender: TObject);
    procedure opt_timestampingClick(Sender: TObject);
    procedure opt_mirrorClick(Sender: TObject);
    procedure opt_recursiveClick(Sender: TObject);
    procedure opt_levelClick(Sender: TObject);
    procedure DownloadBtnClick(Sender: TObject);
    procedure MoreOptionsBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DownloadBtnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    path_to_wget: String;
    function getCMDLine: String;
  public
    function getWGETPath: String;
  end;

var
  MainForm: TMainForm;

implementation

uses About, MoreOpts;

{$R *.DFM}

procedure TMainForm.AboutBtnClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;


procedure TMainForm.opt_timestampingClick(Sender: TObject);
begin
  if (not (Sender as TCheckBox).Checked) then
    opt_mirror.Checked:=False;
end;

procedure TMainForm.opt_mirrorClick(Sender: TObject);
begin
  if ((Sender as TCheckBox).Checked) then begin
    opt_timestamping.Checked:=True;
    opt_recursive.Checked:=True;
    opt_level.Checked:=True;
    levelEdit.Text:='0';
  end;
end;

procedure TMainForm.opt_recursiveClick(Sender: TObject);
begin
  recursiveOptionsGB.Visible:=(Sender as TCheckBox).Checked;
  if ((Sender as TCheckBox).Checked) then begin
    opt_level.Visible:=True;
  end else begin
    opt_mirror.Checked:=False;
    opt_level.Visible:=False;
  end;
end;

procedure TMainForm.opt_levelClick(Sender: TObject);
begin
  levelEdit.Visible:=(Sender as TCheckBox).Checked;
end;

function TMainForm.getCMDLine: String;
var
  s: String;
  i: Integer;
begin
  s:='';
//  s:='c:\command.com /k ';
  s:=s+getWGETPath+' ';
  if (opt_continue.Checked) then s:=s+'-c ';
  if (opt_timestamping.Checked) then s:=s+'-N ';
  if (opt_recursive.Checked) then begin
    s:=s+'-r ';
    if (opt_level.Checked) then begin
      i:=StrToInt(levelEdit.Text);
      if (i<0) then raise EConvertError.Create('Rekursionstiefe ist kleiner als 0.');
      s:=s+'-l'+IntToStr(i)+' ';
    end;
    if (opt_span_hosts.Checked) then s:=s+'-H ';
    if (opt_no_parent.Checked) then s:=s+'-np ';
    if (opt_relative.Checked) then s:=s+'-L ';
    if (opt_follow_ftp.Checked) then s:=s+'--follow-ftp ';
    if (opt_convert_links.Checked) then s:=s+'-k ';
  end;
  //Nun kommt der ganze Krempel von MoreOptions
  with MoreOptionsForm do begin
    if (opt_output_file.Checked) then s:=s+'-o"'+output_fileEdit.Text+'" ';
    if (opt_debug.Checked) then s:=s+'-d ';
    if (opt_non_verbose.Checked) then s:=s+'-nv ';
    if (opt_tries.Checked) then s:=s+'-t'+triesEdit.Text+' ';
    if (opt_no_clobber.Checked) then s:=s+'-nc ';
    if (opt_dot_style.Checked) then case dot_styleComboBox.ItemIndex of
      0: s:=s+'--dot-style=micro ';
      1: s:=s+'--dot-style=default ';
      2: s:=s+'--dot-style=binary ';
      3: s:=s+'--dot-style=mega '; end;
    if (opt_server_response.Checked) then s:=s+'-S ';
    if (opt_timeout.Checked) then s:=s+'-T'+timeoutEdit.Text+' ';
    if (opt_wait.Checked) then s:=s+'-w'+waitEdit.Text+' ';
    if (opt_no_proxy.Checked) then s:=s+'--proxy=off ';
    if (opt_quota.Checked) then s:=s+'-Q'+quotaEdit.Text+' ';
    if (globOn.Checked) then s:=s+'--glob=on '
       else if (globOff.Checked) then s:=s+'--glob=off ';
    if (opt_http_user.Checked) then s:=s+'--http-user='+http_userEdit.Text+' ';
    if (opt_http_passwd.Checked) then s:=s+'--http-passwd='+http_passwdEdit.Text+' ';
    if (opt_proxy_user.Checked) then s:=s+'--proxy-user='+proxy_userEdit.Text+' ';
    if (opt_proxy_passwd.Checked) then s:=s+'--proxy-passwd='+proxy_passwdEdit.Text+' ';
    if (opt_ignore_length.Checked) then s:=s+'--ignore-length ';
    if (opt_user_agent.Checked) then s:=s+'-U"'+user_agentEdit.Text+'" ';
    if (opt_cache_off.Checked) then s:=s+'--cache=off ';
    if (opt_save_headers.Checked) then s:=s+'-s ';
    if (opt_retr_symlinks.Checked) then s:=s+'--retr-symlinks ';
    if (opt_passive_ftp.Checked) then s:=s+'--passive-ftp ';
    if (opt_dont_remove_listing.Checked) then s:=s+'-nr ';
    if (opt_accept.Checked) then s:=s+'-A"'+acceptEdit.Text+'" ';
    if (opt_reject.Checked) then s:=s+'-R"'+rejectEdit.Text+'" ';
    if (opt_domains.Checked) then s:=s+'-D"'+domainsEdit.Text+'" ';
    if (opt_exclude_domains.Checked) then s:=s+'--exclude-domains="'+exclude_domainsEdit.Text+'" ';
    if (opt_include_directories.Checked) then s:=s+'-I"'+include_directoriesEdit.Text+'" ';
    if (opt_exclude_directories.Checked) then s:=s+'-X"'+exclude_directoriesEdit.Text+'" ';
    if (opt_no_host_lookup.Checked) then s:=s+'-nh ';
    s:=s+AdditionalArgsEdit.Text+' ';
  end;
  s:=s+URLEdit.Text;
  Result:=s;
end;

procedure TMainForm.DownloadBtnClick(Sender: TObject);
var
  s: String;
begin
  s:=getCMDLine;
  if (directory_prefixEdit.Text<>'') then begin
    if (not DirectoryExists(directory_prefixEdit.Text)) then begin
      if MessageDlg('Das angegebene Verzeichnis existiert nicht. Soll es erstellt werden?',
                    mtConfirmation,[mbYes,mbNo],0)=mrNo then Exit;
      ForceDirectories(directory_prefixEdit.Text);
      if (not DirectoryExists(directory_prefixEdit.Text)) then begin
        MessageDlg('Verzeichnis konnte nicht erstellt werden.',mtError,[mbOK],0);
        Exit;
      end;
    end;
    if (not SetCurrentDirectory(PChar(directory_prefixEdit.Text))) then begin
      MessageDlg('Kann nicht ins angegebene Verzeichnis wechseln!',mtError,
                 [mbOK],0);
      Exit;
    end;
  end;

  if (WinExec(PChar(s),SW_SHOWNORMAL)<=30) then
    MessageDlg('wget wurde nicht gefunden. Bitte als Kommandozeilenparameter '+
               'den kompletten Pfad zu wget angeben!',mtError,[mbOK],0);
end;

procedure TMainForm.MoreOptionsBtnClick(Sender: TObject);
begin
  MoreOptionsForm.ShowModal;
end;

function TMainForm.getWGETPath: String;
begin
  Result:=path_to_wget;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Self.Handle, true);
  if (ParamCount=0) then begin
    path_to_wget:=ExtractFileDir(ParamStr(0))+'\wget.exe';
    while Pos('\\',path_to_wget)>0 do Delete(path_to_wget,Pos('\\',path_to_wget),1);
  end else
    path_to_wget:=ParamStr(1);
  if (not FileExists(path_to_wget)) then begin
    MessageDlg('wget.exe wurde nicht gefunden. Starten Sie dieses Programm entweder '+
               'im selben Verzeichnis wie wget oder bergeben Sie als Parameter '+
               'den kompletten Pfad zu wget!',mtError,[mbOK],0);
    Application.Terminate;
  end;
end;

procedure TMainForm.DownloadBtnMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  DownloadBtn.Hint:=getCMDLine;
end;

end.
